package com.hai.dao;

import com.hai.entity.ApiKfcStores;
import com.hai.entity.ApiKfcStoresExample.Criteria;
import com.hai.entity.ApiKfcStoresExample.Criterion;
import com.hai.entity.ApiKfcStoresExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class ApiKfcStoresSqlProvider {

    public String countByExample(ApiKfcStoresExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("api_kfc_stores");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(ApiKfcStoresExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("api_kfc_stores");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(ApiKfcStores record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("api_kfc_stores");
        
        if (record.getCityNameFirstLetter() != null) {
            sql.VALUES("city_name_first_letter", "#{cityNameFirstLetter,jdbcType=VARCHAR}");
        }
        
        if (record.getCityCode() != null) {
            sql.VALUES("city_code", "#{cityCode,jdbcType=VARCHAR}");
        }
        
        if (record.getCityName() != null) {
            sql.VALUES("city_name", "#{cityName,jdbcType=VARCHAR}");
        }
        
        if (record.getProvinceName() != null) {
            sql.VALUES("province_name", "#{provinceName,jdbcType=VARCHAR}");
        }
        
        if (record.getProvinceCode() != null) {
            sql.VALUES("province_code", "#{provinceCode,jdbcType=VARCHAR}");
        }
        
        if (record.getKfcCityId() != null) {
            sql.VALUES("kfc_city_id", "#{kfcCityId,jdbcType=INTEGER}");
        }
        
        if (record.getKfcCityCode() != null) {
            sql.VALUES("kfc_city_code", "#{kfcCityCode,jdbcType=VARCHAR}");
        }
        
        if (record.getStoreName() != null) {
            sql.VALUES("store_name", "#{storeName,jdbcType=VARCHAR}");
        }
        
        if (record.getStoreCode() != null) {
            sql.VALUES("store_code", "#{storeCode,jdbcType=VARCHAR}");
        }
        
        if (record.getLon() != null) {
            sql.VALUES("lon", "#{lon,jdbcType=VARCHAR}");
        }
        
        if (record.getLat() != null) {
            sql.VALUES("lat", "#{lat,jdbcType=VARCHAR}");
        }
        
        if (record.getAddress() != null) {
            sql.VALUES("address", "#{address,jdbcType=VARCHAR}");
        }
        
        if (record.getStartTime() != null) {
            sql.VALUES("start_time", "#{startTime,jdbcType=VARCHAR}");
        }
        
        if (record.getEndTime() != null) {
            sql.VALUES("end_time", "#{endTime,jdbcType=VARCHAR}");
        }
        
        if (record.getStoreStatus() != null) {
            sql.VALUES("store_status", "#{storeStatus,jdbcType=INTEGER}");
        }
        
        if (record.getShelfStatus() != null) {
            sql.VALUES("shelf_status", "#{shelfStatus,jdbcType=INTEGER}");
        }
        
        if (record.getDistance() != null) {
            sql.VALUES("distance", "#{distance,jdbcType=VARCHAR}");
        }
        
        if (record.getOperatorId() != null) {
            sql.VALUES("operator_id", "#{operatorId,jdbcType=BIGINT}");
        }
        
        if (record.getOperatorName() != null) {
            sql.VALUES("operator_name", "#{operatorName,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(ApiKfcStoresExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("city_name_first_letter");
        sql.SELECT("city_code");
        sql.SELECT("city_name");
        sql.SELECT("province_name");
        sql.SELECT("province_code");
        sql.SELECT("kfc_city_id");
        sql.SELECT("kfc_city_code");
        sql.SELECT("store_name");
        sql.SELECT("store_code");
        sql.SELECT("lon");
        sql.SELECT("lat");
        sql.SELECT("address");
        sql.SELECT("start_time");
        sql.SELECT("end_time");
        sql.SELECT("store_status");
        sql.SELECT("shelf_status");
        sql.SELECT("distance");
        sql.SELECT("operator_id");
        sql.SELECT("operator_name");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("`status`");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("api_kfc_stores");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        ApiKfcStores record = (ApiKfcStores) parameter.get("record");
        ApiKfcStoresExample example = (ApiKfcStoresExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("api_kfc_stores");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getCityNameFirstLetter() != null) {
            sql.SET("city_name_first_letter = #{record.cityNameFirstLetter,jdbcType=VARCHAR}");
        }
        
        if (record.getCityCode() != null) {
            sql.SET("city_code = #{record.cityCode,jdbcType=VARCHAR}");
        }
        
        if (record.getCityName() != null) {
            sql.SET("city_name = #{record.cityName,jdbcType=VARCHAR}");
        }
        
        if (record.getProvinceName() != null) {
            sql.SET("province_name = #{record.provinceName,jdbcType=VARCHAR}");
        }
        
        if (record.getProvinceCode() != null) {
            sql.SET("province_code = #{record.provinceCode,jdbcType=VARCHAR}");
        }
        
        if (record.getKfcCityId() != null) {
            sql.SET("kfc_city_id = #{record.kfcCityId,jdbcType=INTEGER}");
        }
        
        if (record.getKfcCityCode() != null) {
            sql.SET("kfc_city_code = #{record.kfcCityCode,jdbcType=VARCHAR}");
        }
        
        if (record.getStoreName() != null) {
            sql.SET("store_name = #{record.storeName,jdbcType=VARCHAR}");
        }
        
        if (record.getStoreCode() != null) {
            sql.SET("store_code = #{record.storeCode,jdbcType=VARCHAR}");
        }
        
        if (record.getLon() != null) {
            sql.SET("lon = #{record.lon,jdbcType=VARCHAR}");
        }
        
        if (record.getLat() != null) {
            sql.SET("lat = #{record.lat,jdbcType=VARCHAR}");
        }
        
        if (record.getAddress() != null) {
            sql.SET("address = #{record.address,jdbcType=VARCHAR}");
        }
        
        if (record.getStartTime() != null) {
            sql.SET("start_time = #{record.startTime,jdbcType=VARCHAR}");
        }
        
        if (record.getEndTime() != null) {
            sql.SET("end_time = #{record.endTime,jdbcType=VARCHAR}");
        }
        
        if (record.getStoreStatus() != null) {
            sql.SET("store_status = #{record.storeStatus,jdbcType=INTEGER}");
        }
        
        if (record.getShelfStatus() != null) {
            sql.SET("shelf_status = #{record.shelfStatus,jdbcType=INTEGER}");
        }
        
        if (record.getDistance() != null) {
            sql.SET("distance = #{record.distance,jdbcType=VARCHAR}");
        }
        
        if (record.getOperatorId() != null) {
            sql.SET("operator_id = #{record.operatorId,jdbcType=BIGINT}");
        }
        
        if (record.getOperatorName() != null) {
            sql.SET("operator_name = #{record.operatorName,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("api_kfc_stores");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("city_name_first_letter = #{record.cityNameFirstLetter,jdbcType=VARCHAR}");
        sql.SET("city_code = #{record.cityCode,jdbcType=VARCHAR}");
        sql.SET("city_name = #{record.cityName,jdbcType=VARCHAR}");
        sql.SET("province_name = #{record.provinceName,jdbcType=VARCHAR}");
        sql.SET("province_code = #{record.provinceCode,jdbcType=VARCHAR}");
        sql.SET("kfc_city_id = #{record.kfcCityId,jdbcType=INTEGER}");
        sql.SET("kfc_city_code = #{record.kfcCityCode,jdbcType=VARCHAR}");
        sql.SET("store_name = #{record.storeName,jdbcType=VARCHAR}");
        sql.SET("store_code = #{record.storeCode,jdbcType=VARCHAR}");
        sql.SET("lon = #{record.lon,jdbcType=VARCHAR}");
        sql.SET("lat = #{record.lat,jdbcType=VARCHAR}");
        sql.SET("address = #{record.address,jdbcType=VARCHAR}");
        sql.SET("start_time = #{record.startTime,jdbcType=VARCHAR}");
        sql.SET("end_time = #{record.endTime,jdbcType=VARCHAR}");
        sql.SET("store_status = #{record.storeStatus,jdbcType=INTEGER}");
        sql.SET("shelf_status = #{record.shelfStatus,jdbcType=INTEGER}");
        sql.SET("distance = #{record.distance,jdbcType=VARCHAR}");
        sql.SET("operator_id = #{record.operatorId,jdbcType=BIGINT}");
        sql.SET("operator_name = #{record.operatorName,jdbcType=VARCHAR}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        ApiKfcStoresExample example = (ApiKfcStoresExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(ApiKfcStores record) {
        SQL sql = new SQL();
        sql.UPDATE("api_kfc_stores");
        
        if (record.getCityNameFirstLetter() != null) {
            sql.SET("city_name_first_letter = #{cityNameFirstLetter,jdbcType=VARCHAR}");
        }
        
        if (record.getCityCode() != null) {
            sql.SET("city_code = #{cityCode,jdbcType=VARCHAR}");
        }
        
        if (record.getCityName() != null) {
            sql.SET("city_name = #{cityName,jdbcType=VARCHAR}");
        }
        
        if (record.getProvinceName() != null) {
            sql.SET("province_name = #{provinceName,jdbcType=VARCHAR}");
        }
        
        if (record.getProvinceCode() != null) {
            sql.SET("province_code = #{provinceCode,jdbcType=VARCHAR}");
        }
        
        if (record.getKfcCityId() != null) {
            sql.SET("kfc_city_id = #{kfcCityId,jdbcType=INTEGER}");
        }
        
        if (record.getKfcCityCode() != null) {
            sql.SET("kfc_city_code = #{kfcCityCode,jdbcType=VARCHAR}");
        }
        
        if (record.getStoreName() != null) {
            sql.SET("store_name = #{storeName,jdbcType=VARCHAR}");
        }
        
        if (record.getStoreCode() != null) {
            sql.SET("store_code = #{storeCode,jdbcType=VARCHAR}");
        }
        
        if (record.getLon() != null) {
            sql.SET("lon = #{lon,jdbcType=VARCHAR}");
        }
        
        if (record.getLat() != null) {
            sql.SET("lat = #{lat,jdbcType=VARCHAR}");
        }
        
        if (record.getAddress() != null) {
            sql.SET("address = #{address,jdbcType=VARCHAR}");
        }
        
        if (record.getStartTime() != null) {
            sql.SET("start_time = #{startTime,jdbcType=VARCHAR}");
        }
        
        if (record.getEndTime() != null) {
            sql.SET("end_time = #{endTime,jdbcType=VARCHAR}");
        }
        
        if (record.getStoreStatus() != null) {
            sql.SET("store_status = #{storeStatus,jdbcType=INTEGER}");
        }
        
        if (record.getShelfStatus() != null) {
            sql.SET("shelf_status = #{shelfStatus,jdbcType=INTEGER}");
        }
        
        if (record.getDistance() != null) {
            sql.SET("distance = #{distance,jdbcType=VARCHAR}");
        }
        
        if (record.getOperatorId() != null) {
            sql.SET("operator_id = #{operatorId,jdbcType=BIGINT}");
        }
        
        if (record.getOperatorName() != null) {
            sql.SET("operator_name = #{operatorName,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, ApiKfcStoresExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}